﻿using IRaCIS.Core.Application.Helper;
using IRaCIS.Core.Domain.Share;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.FileProviders;
using System.IO;

namespace IRaCIS.Core.API
{
    public static class IRacisHostFileStore
    {

        public static void UseIRacisHostStaticFileStore(this IApplicationBuilder app, IWebHostEnvironment _hostEnvironment)
        {
      
           var iRaCISDataFolder = FileStoreHelper.GetIRaCISRootDataFolder(_hostEnvironment);

            if (!Directory.Exists(iRaCISDataFolder))
            {
                Directory.CreateDirectory(iRaCISDataFolder);
            }

            app.UseStaticFiles(new StaticFileOptions
            {
                FileProvider = new PhysicalFileProvider(iRaCISDataFolder),
                RequestPath = $"/{StaticData.IRaCISDataFolder}"
            });



            #region 后期废弃


            var uploadPath = Path.Combine(Directory.GetParent(_hostEnvironment.ContentRootPath.TrimEnd('\\')).FullName, StaticData.UploadFileFolder);
           

            if (!Directory.Exists(uploadPath))
            {
                Directory.CreateDirectory(uploadPath);
            }

            app.UseStaticFiles(new StaticFileOptions
            {
                FileProvider = new PhysicalFileProvider(uploadPath),
                RequestPath = $"/{StaticData.UploadFileFolder}"
            });

          


            #endregion






        }
    }
}
