

using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using IRaCIS.Core.Domain.Share.Reading;

namespace IRaCIS.Core.Domain.Models
{
	///<summary>
	///阅片期设置
	///</summary>
	[Table("ReadingPeriodSet")]
	public class ReadingPeriodSet : Entity, IAuditAdd
	{

		/// <summary>
		/// 项目ID
		/// </summary>
		public Guid? TrialId { get; set; }

		/// <summary>
		/// 阅片期名称
		/// </summary>
		public string ReadingPeriodName { get; set; }

		/// <summary>
		/// 受试者范围
		/// </summary>
		public SubjectScopeEnum? SubjectScope { get; set; }

		/// <summary>
		/// 范围ID
		/// </summary>
		public Guid? ScopeId { get; set; }

		/// <summary>
		/// 截止日期
		/// </summary>
		public DateTime ExpirationDate { get; set; }

		/// <summary>
		/// 截止访视
		/// </summary>
		public decimal ExpirationVisit { get; set; }

		/// <summary>
		/// 状态
		/// </summary>
		public int? Status { get; set; }

		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreateTime { get; set; }

		/// <summary>
		/// 创建人
		/// </summary>
		public Guid CreateUserId { get; set; }

	}



}
